//
// TCoolReference and TCoolBuff header
//
// Copyright (C) 1999-2001 Hewlett Packard
// By John Schettino, schettj@hpl.hp.com
//

// CVS info
/*
$Header: /home/cvs/Hack/Esquirt/Linux/compat/TCoolReference.h,v 2.6 2001/05/09 21:30:39 jeant Exp $
*/
/*
$Log: TCoolReference.h,v $
Revision 2.6  2001/05/09 21:30:39  jeant
Proper licensing terms (thanks to Mirjana)...

Revision 2.5  2001/04/21 02:22:21  jeant
RUI goodness (unescape/parse) and associated test programs. Updated official API from latest Palm header. More bugs fixed. Still not fully tested.

Revision 2.4.3.1  2001/02/16 23:57:34  jeant
Imported sources

*/
/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/


#ifndef __TCOOLREFERENCE__
#define __TCOOLREFERENCE__


// A TCoolBuffer is a content block and a length

typedef struct _TCoolBuffer {
  unsigned char * content; 
  unsigned int length;
} TCoolBuffer;

// This would be the base class for a TCoolReference, in C++ systems
// For C-based code, these two types are almost interchangable

typedef struct _TCoolReference {
  unsigned char * content; 
  unsigned int length;
  char * encoding;
} TCoolReference;



// define functions to manipulate a TCoolBuffer struct

// malloc an empty ref, no content memory
TCoolBuffer * TCoolBuffer_Allocate();

// malloc a ref & ref->content, copy in content
TCoolBuffer * TCoolBuffer_Allocate(const TCoolBuffer& ref); 

// malloc ref & ref->content, copy in val
TCoolBuffer * TCoolBuffer_Allocate(const unsigned char *value, unsigned int len); 

// malloc ref & ref->content, unintialized
TCoolBuffer * TCoolBuffer_Allocate(unsigned int len);

// free ref->content and then ref
void TCoolBuffer_Free(TCoolBuffer *ref);

// get a const * to content
#define TCoolBuffer_Content(ref)        ((unsigned char *) (ref->content))

// get length
#define TCoolBuffer_Length(ref) (ref->length)


// TCoolReference fns

TCoolReference * TCoolReference_Allocate();

// malloc a ref & ref->content, copy in content
TCoolReference * TCoolReference_Allocate(const TCoolReference& ref);

// malloc ref & ref->content, copy in val
TCoolReference * TCoolReference_Allocate(const unsigned char *value, unsigned int len, char * encode=0);

// malloc ref & ref->content, unintialized
TCoolReference * TCoolReference_Allocate(unsigned int len);


// free ref->content, ref->encode, and then ref
void TCoolReference_Free(TCoolReference *ref);

// get a const * to content
#define TCoolReference_Content(ref)     ((unsigned char *) (ref->content))

// get length
#define TCoolReference_Length(ref)      (ref->length)

// get encode
#define TCoolReference_Encoding(ref) (ref->encoding)

// get a token value from the XML string in a reference
char * TCoolReference_FindXmlToken(char * token, TCoolReference *ref);


#endif
