/*
 *			    Test RUI helpers
 *			    ----------------
 *
 *		Jean II '01
 *
 * Escape a URI
 *
 * This file is released under the GPL license.
 *
 * Compile with : gcc -O2 -o escape_uri escape_uri.c ../libsquirt.a
 */

/*
 * CVS blurb
 * $Header: /home/cvs/Hack/Esquirt/Linux/tests/escape_uri.c,v 2.3 2001/05/09 21:30:39 jeant Exp $
 * $Log: escape_uri.c,v $
 * Revision 2.3  2001/05/09 21:30:39  jeant
 * Proper licensing terms (thanks to Mirjana)...
 *
 * Revision 2.2  2001/04/24 00:53:07  jeant
 * The good one : fix remaining bugs found during Linux<->Linux testing
 *
 *
 */
/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <squirt.h>

/******************************* MAIN *******************************/

/* ---------------------------------------------------------------- */
/*
 * main body of the program
 */
int
main(int	argc,
     char *	argv[])
{
  char		src[1024];
  char		dest[1024];
  int		len;
  int		newline = 0;

  /* Read string from stdin */
  fgets(src, 1024, stdin);

  /* Remove '\n' at the end */
  len = strlen(src);
  if(src[len - 1] == '\n')
    {
      newline = 1;
      src[len - 1] = '\0';
    }

  /* Escape it */
  escape_uri(dest, 1024, src);

  /* Dump on stdout */
  fputs(dest, stdout);

  /* Add newline if needed */
  if(newline)
    fputc('\n', stdout);

  return(0);
}
