/*
 *			    IrDA socket Beacon
 *			    ------------------
 *
 *		Jean II '99 & '00
 *
 * Send and receive e-Squirt using regular IrDA sockets.
 * Now, the generic code has been move to squirt_common.c...
 *
 * This file is released under the GPL license.
 */

/*
 * CVS blurb
 * $Header: /home/cvs/Hack/Esquirt/Linux/tests/socket_beacon.c,v 2.6 2001/05/09 21:30:39 jeant Exp $
 * $Log: socket_beacon.c,v $
 * Revision 2.6  2001/05/09 21:30:39  jeant
 * Proper licensing terms (thanks to Mirjana)...
 *
 * Revision 2.5  2001/04/19 18:56:25  jeant
 * Temporary release, not fully functional
 * Reworked native API
 * Got type/accept/target Obex headers working properly
 * Updated tests
 *
 * Revision 2.4.3.1  2001/02/16 23:57:34  jeant
 * Imported sources
 *
 */
/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <squirt.h>

/*#define BROWSER		"lynx %s"*/
//#define BROWSER		"netscape %s &"

/***************************** RECEIVER *****************************/

/* ---------------------------------------------------------------- */
/*
 * Receive a e-Squirt of Beacon. Non forking.
 */
int
receive_esquirt(es_squirt *	fields,		/* Rx payload */
		es_opt *	options,	/* Rx options */
		es_trans *	extra,		/* Not used */
		gi_obget *	ret_hdr,	/* Not used */
		gi_flags *	ret_flags)	/* Not used */
{
  debug_squirt(fields, options, extra);

#ifdef BROWSER
  {
    unsigned char		buf[512];	/* The command */
    sprintf(buf, BROWSER, fields->url);
    system(buf);
  }
#endif

  /* Return back to the server */
  return(0);
}

/******************************* MAIN *******************************/

/* ---------------------------------------------------------------- */
/*
 * main body of the program
 */
int
main(int	argc,
     char *	argv[])
{
  es_squirt	fields;
  es_opt	options;
  int		ret = -1;

  init_structs(&fields, &options, NULL, NULL, NULL, NULL);
  /* Set the options */
  options.xml = OPT_XML_STD;
  options.model = OPT_BEACON;
  options.transport = OPT_IRDA;
  options.protocol = OPT_RAW;

  /* Look if there is any command line args */
  switch(argc)
    {
    case 0:
      /* Fallthrough */
    case 1:
      /* No argument : receive a beacon */
      break;
    case 2:
      /* One argument : the URL */
      strcpy(fields.url, argv[1]);
      options.xml = OPT_XML_URL;
      break;
    case 3:
      /* Two arguments : label + url */
      strcpy(fields.label, argv[1]);
      strcpy(fields.url, argv[2]);
      break;
    default:
      /* Fallthrough */
    case 4:
      /* Three arguments : label + url + type */
      strcpy(fields.label, argv[1]);
      strcpy(fields.url, argv[2]);
      strcpy(fields.type, argv[3]);
      break;
    }

  if(argc > 1)
    {
      /* Send a single e-Squirt/Beacon */
      ret = send_squirt(&fields, &options, NULL, NULL, NULL);
      if(ret < 0)
	printf("Sending e-Squirt failed...\n");
    }
  else
    {
      /* Receive multiple e-Squirt/Beacon */
      printf("Waiting for e-Squirts over socket...\n");
      recv_squirt(&fields, &options, NULL, &receive_esquirt, NULL);
      /* Will loop forever */
    }

  return(ret);
}
